#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <ctype.h>
#include "dynstring.h"

/*
 * #include "finder_extern.h"
 */

#define MAX_SUB_DIALOGUE 100
#define SLEN 1000
#define defaultTimelimit 3
#define defaultSeed 1

#ifndef boolean
#define boolean char
#define false ((boolean)0)
#define true ((boolean)1)
#endif

typedef enum {
  protect,
  unprotect,
  change_time_limit,
  /*
   *  add,
   *  delete
   */
  halt
} event;


typedef struct {
  int id;
  dynstring s;
  int weight;
  int var_count;
  char **var_name;
  char **var_sort;
  int softweight;
  boolean sacred;
  boolean satisfied;
  boolean flip;
} DCLAUSE, *dclause;

typedef struct clause_pointer {
  dclause c;
  struct clause_pointer *last;
  struct clause_pointer *next;
} CLAUSELIST, *clauselist;

typedef struct dialogue_structure {
  event e;
  clauselist parameters;
  int time;
  struct dialogue_structure *sub[MAX_SUB_DIALOGUE];
  struct dialogue_structure *parent;
} DIALOGUE, *dialogue;




void nonce_filename(char *path);
boolean file_exists(char *path);
void get_problem_basis(char *source, char *dest);
clauselist get_problem_clauses(char *filename);
dclause get_dclause(char *line);
void generate_diagnosis(char *sorts_and_functions, clauselist clauses);
void report_no_model(clauselist clauses);
void report_model(clauselist clauses);
dialogue next_action(clauselist clauses, dialogue history);
clauselist add_parameter(dclause c, clauselist cl);
int next_int(char *s);
boolean digit_in(char *s);
void display_current(clauselist clauses);
dialogue new_dialogue(dialogue d, event e);


/*------ The following are in file FINDER.c -----------------------------*/

int found( const dynstring *s, int add_if_true, int seek_model );
boolean clause_is_long(void);
void init_init_finder(void);
boolean init_finder(char filename[]);
void transfer_job(char *source, char *dest);
void go(int x);
void refute_current(void);
int theory_size(int x);
void finder_input( const dynstring *s );
void short_timesup(int x);
boolean initial_model_found(void);
void set_no_semantics(void);
int no_semantics_set(void);
void set_job_only(void);
void unset_job_only(void);
void FINDER_cleanup(void);
void print_model_anyway(void);

void inerror(char *s1, char *s2);
