#include "FINDER.h"



int clausify(clause source, CLAUSE dest[])
{
  int dest_size = 1;
  boolean replaced[CL_MAX];
  int x,y;
  wff_stack wptr;

  for (x=0; x<CL_MAX; x++) replaced[x] = false;
  copy_clause(source,dest);
  for (x=0; x<dest_size; x++) {
    for (wptr=dest[x].prem; wptr && !replaced[x]; wptr=wptr->nxt) {
      if (!strcmp(wptr->w->sym->fname,"NOT")) {
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].prem = remove_wff(dest[dest_size].prem,wptr->w);
	dest[dest_size].conc = add_wff(dest[dest_size].conc,wptr->w->sb[0]);
	dest_size++;
	replaced[x] = true;
      }
      else if (!strcmp(wptr->w->sym->fname,"AND")) {
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].prem = remove_wff(dest[dest_size].prem,wptr->w);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[0]);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[1]);
	dest_size++;
	replaced[x] = true;
      }
      else if (!strcmp(wptr->w->sym->fname,"OR")) {
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].prem = remove_wff(dest[dest_size].prem,wptr->w);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[0]);
	dest_size++;
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].prem = remove_wff(dest[dest_size].prem,wptr->w);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[1]);
	dest_size++;
	replaced[x] = true;
      }
      else if (wptr->w->sym->fname[0] == '=' &&
	       wptr->w->sb[0]->sym->val_type == Bool) {
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].prem = remove_wff(dest[dest_size].prem,wptr->w);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[0]);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[1]);
	dest_size++;
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].prem = remove_wff(dest[dest_size].prem,wptr->w);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[0]);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[1]);
	dest_size++;
	replaced[x] = true;
      }
    }
    for (wptr=dest[x].conc; wptr && !replaced[x]; wptr=wptr->nxt) {
      if (!strcmp(wptr->w->sym->fname,"NOT")) {
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].conc = remove_wff(dest[dest_size].conc,wptr->w);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[0]);
	dest_size++;
	replaced[x] = true;
      }
      else if (!strcmp(wptr->w->sym->fname,"OR")) {
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].conc = remove_wff(dest[dest_size].conc,wptr->w);
	dest[dest_size].conc = add_wff(dest[dest_size].conc,wptr->w->sb[0]);
	dest[dest_size].conc = add_wff(dest[dest_size].conc,wptr->w->sb[1]);
	dest_size++;
	replaced[x] = true;
      }
      else if (!strcmp(wptr->w->sym->fname,"AND")) {
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].conc = remove_wff(dest[dest_size].conc,wptr->w);
	dest[dest_size].conc = add_wff(dest[dest_size].conc,wptr->w->sb[0]);
	dest_size++;
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].conc = remove_wff(dest[dest_size].conc,wptr->w);
	dest[dest_size].conc = add_wff(dest[dest_size].conc,wptr->w->sb[1]);
	dest_size++;
	replaced[x] = true;
      }
      else if (wptr->w->sym->fname[0] == '=' &&
	       wptr->w->sb[0]->sym->val_type == Bool) {
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].conc = remove_wff(dest[dest_size].conc,wptr->w);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[0]);
	dest[dest_size].conc = add_wff(dest[dest_size].conc,wptr->w->sb[1]);
	dest_size++;
	copy_clause(dest+x,dest+dest_size);
	dest[dest_size].conc = remove_wff(dest[dest_size].conc,wptr->w);
	dest[dest_size].conc = add_wff(dest[dest_size].conc,wptr->w->sb[0]);
	dest[dest_size].prem = add_wff(dest[dest_size].prem,wptr->w->sb[1]);
	dest_size++;
	replaced[x] = true;
      }
    }
    if (replaced[x])  free_clause_parts(dest+x);
  }
  replaced[dest_size] = true;
  for (x=0; x<dest_size; x++)
    if (replaced[x]) {
      for (y=x+1; y<dest_size; y++)
	if (!replaced[y]) {
	  copy_clause(dest+y,dest+x);
	  free_clause_parts(dest+y);
	  replaced[y] = true;
	  replaced[x] = false;
	  break;
	}
    }
  for (x=0; x<dest_size; x++) {
    if (replaced[x])
      return x;
    end_parse(dest+x);
    get_weight(dest+x);
  }
  return dest_size;
}


/*
 * Simply make a copy of the contents of c
 */

void copy_clause(clause c, clause d)
{
  wff_stack wptr;

  free_wff_list(d->prem);
  d->prem = 0;
  for(wptr=c->prem; wptr; wptr=wptr->nxt)
    d->prem = add_wff(d->prem,wptr->w);
  free_wff_list(d->conc);
  d->conc = 0;
  for(wptr=c->conc; wptr; wptr=wptr->nxt)
    d->conc = add_wff(d->conc,wptr->w);
  free_wff_list(d->varlist);
  d->varlist = 0;
  for(wptr=c->varlist; wptr; wptr=wptr->nxt)
    d->varlist = add_wff(d->varlist,wptr->w);
  free_wff_list(d->testlist);
  d->testlist = 0;
  for(wptr=c->testlist; wptr; wptr=wptr->nxt)
    d->testlist = add_wff(d->testlist,wptr->w);
  d->weight = c->weight;
  d->varcount = c->varcount;
  d->softweight = c->softweight;
  d->badness = c->badness;
  d->preprocessed = c->preprocessed;
}


void free_clause_parts(clause c)
{
  if (!c) return;
  free_wff_list(c->prem);
  c->prem = 0;
  free_wff_list(c->conc);
  c->conc = 0;
  free_wff_list(c->varlist);
  c->varlist = 0;
  free_wff_list(c->testlist);
  c->testlist = 0;
}


wff_stack remove_wff(wff_stack thelist, wff w)
{
  wff_stack ptr, trail;

  if (!thelist) return 0;
  if (thelist->w == w) {
    ptr = thelist->nxt;
    free(thelist);
    return ptr;
  }
  for (ptr=thelist->nxt,trail=thelist;
       ptr;
       ptr=ptr->nxt,trail=trail->nxt)
    if (ptr->w == w) {
      trail->nxt = ptr->nxt;
      free(ptr);
      break;
    }
  return thelist;
}


wff_stack add_wff(wff_stack thelist, wff w)
{
  wff_stack ptr;

  for (ptr=thelist; ptr; ptr=ptr->nxt)
    if (ptr->w == w)
      return thelist;
  ptr = (wff_stack) malloc(sizeof(WFF_STACK));
  ptr->nxt = thelist;
  ptr->w = w;
  return ptr;
}
