#define MAINFILE
#include "FINDER.h"

int main(argc,argv)

int argc;
char *argv[];
{
  int option;
  char filename[64];
  FILE *infil;
  void timesup();
  void intrupt();
  boolean pipe_out = false;

  piping = false;
  pipe_open = false;
  negative = false;
  pipe_out = false;
  dynstring_initialise(&command_line,"");
  *filename = 0;
  while ((option = getopt (argc, argv, "c:f:n:p")) != -1)
    switch( option ) {
    case 'c': dynstring_strcatc(&command_line,optarg);
      dynstring_strcatc(&command_line," ");
      break;
    case 'f': strcpy(filename,optarg);
      piping = true;
      pipe_open = true;
      break;
    case 'n': strcpy(filename,optarg);
      piping = true;
      pipe_open = true;
      negative = true;
      break;
    case 'p': pipe_out = true;
      break;
    }

  signal( SIGALRM, timesup );
  signal( SIGINT, intrupt );

  initialize();
  read_job( stdin );
  pipe_open = false;
  if ( piping ) {
    if ( !(infil = fopen(filename,"r")) )
      inerror("Cannot open file",filename);
    read_job( infil );
  }
  if ( *(command_line.c_str) ) {
    cmd_line_input = true;
    input_point = 0;
    dynstring_strcatc( &command_line, " end." );
    read_job(0);
  }
  if ( pipe_out ) {
    dynstring_strcpyc( &command_line, "setting ugly end." );
    cmd_line_input = true;
    input_point = 0;
    read_job(0);
  }
  tr_parameters.done = 0;
  satisfied = false;
  if (setting.maxtime == 0 || setting.maxtime > MAXTIME)
    setting.maxtime = MAXTIME;
  alarm(setting.maxtime);
  begin_time = timestamp();
  demote_hiddens();
  if (setting.pm.verbosity[pjob]) print_job();
  if (setting.parse_only)
    printf("\nSyntax checked...OK\n");
  else if (piping) {
    while (!tr_parameters.done && got_partial()) {
      satisfied = false;
      go(0);
      if (negative && !satisfied) {
	updates[current_theory]++;
	print_model();
	if (updates[current_theory] && 
	     updates[current_theory] == setting.max_models)
	  job_done(&tr_parameters, "limit on number of solutions");
      }
    }
  }
  else go(0);
  end_time = timestamp();

  if (!setting.pm.pretty)
    printf("end\n");
  if (setting.pm.verbosity[pstats])
    printstats();
  else if (!setting.parse_only && !tr_parameters.reps[SOLUTIONS].i_report)
    printf("\n  No solution found.\n");
  fflush(stdout);

  alarm(0);

  exit (0);
}


/*
* Copy of a function from FINDER.c
*/

static int old_updates;

void go(int x)
{
  if (bug_out) return;

  if (negative && satisfied) return;
  if (!x) old_updates = updates[current_theory];
  if (!sort[x].sname) {
    set_up_cc();
    firstmodel = true; // perhaps need to change this?
    transref(&tr_parameters);
    if (bug_out) return;
  }
  else if (sort[x].piped && !tr_parameters.done) go(x+1);
  else for (sort[x].siz = sort[x].sizmin;
	    sort[x].siz <= sort[x].sizmax && !tr_parameters.done;
	    sort[x].siz++) {
      if (updates[current_theory]==old_updates || !setting.sortcut)
	go(x+1);
    }
}



/*
 * Another copy of a function fromo FINDER.c
 */

#define SHORT_CLAUSE_CUTOFF 4

boolean clause_is_long()
{
#ifdef SOFTIE_SCOTT
  return (latest_clause.weight > SHORT_CLAUSE_CUTOFF);
#else
  return (latest_clause.weight + latest_clause.varcount > 7);
#endif
}


/*
*	Action on signal from alarm.
*/

void timesup()
{
    job_done( &tr_parameters, "time limit" );
}


/*
*	Action on signal from ^C or whatever SIGINT may be.
*/

void intrupt()
{
    job_done( &tr_parameters, "interrupt" );
}
